/**************************************************************
 * Removes All Windows Live Messenger Data Files
 *
 * History
 * 7/27/07 : KenZhan: Created
 * 7/30/07 : KenZhan: Added logs to track usage.
 * 8/01/07 : KenZhan: Fixed problem for removing folder with long pathname.
 * 8/27/07 : KenZhan: Added clean for messenger virtual store.
 *
 **************************************************************/

    var g_wshshell = new ActiveXObject("WScript.Shell");
    var g_filesys = new ActiveXObject("Scripting.FileSystemObject");
    var g_shellApplication = new ActiveXObject("Shell.Application");

    var g_debugging=false;
    var g_ProgramFilesPath ;
    var g_TempPath;
    var g_ComputerName;
    var g_UserName;
    var g_UserDomain;
    var g_MyDoucmentPath;
    var g_LocalApplicationDataPath;
    var g_ApplicationDataPath;
    var g_windir;
    var g_UserProfile;
    var g_success=true; 
    var g_machine="64bit"; 
    var g_failure = [];
    var g_runningPath= "";
    
    //load global variable base on system
    function LoadGlobalVariables()
    {
        var ShellProcess=g_wshshell.Environment("PROCESS");
        //get programfiles path try x86 first
        g_ProgramFilesPath = ShellProcess("ProgramFiles(x86)");
        if(g_ProgramFilesPath=="")
        {
            g_ProgramFilesPath = ShellProcess("ProgramFiles");
            g_machine="32bit";
        }
        g_TempPath = ShellProcess("TEMP");
        g_ComputerName = ShellProcess("ComputerName");
        g_UserName = ShellProcess("UserName");
        g_UserDomain = ShellProcess("UserDomain");
        g_UserProfile=ShellProcess("UserProfile");
        //set local application data path
        g_LocalApplicationDataPath=ShellProcess("LocalAppData");
        //XP doesn't has LocalAppData in environment
        if (g_LocalApplicationDataPath=="")
            g_LocalApplicationDataPath=g_UserProfile+"\\Local Settings\\Application Data";
        //set application data path
        g_ApplicationDataPath=ShellProcess("AppData");
        if (g_ApplicationDataPath=="")
            g_ApplicationDataPath=g_UserProfile+"\\application data"
        g_MyDoucmentPath=g_wshshell.SpecialFolders("MyDocuments");
        g_windir=ShellProcess("windir");
        
        //dump for debugging
        if(g_debugging)
        {
            var buf=[];
            buf.push("Global Variables");
            buf.push("g_ProgramFilesPath ..."+g_ProgramFilesPath);
            buf.push("g_TempPath :"+g_TempPath);
            buf.push("g_UserName :"+g_UserName);
            buf.push("g_UserDomain :"+g_UserDomain);
            buf.push("g_UserProfile :"+g_UserProfile);
            buf.push("g_LocalApplicationDataPath :"+g_LocalApplicationDataPath);
            buf.push("g_ApplicationDataPath :"+g_ApplicationDataPath);
            buf.push("g_MyDoucmentPath :"+g_MyDoucmentPath);
            buf.push("g_windir :"+g_windir);
            WScript.Echo(buf.join("\n"));
        }
        
        // Get script path.
        g_runningPath = WScript.ScriptFullName;
        g_runningPath = g_runningPath.substr(0, g_runningPath.lastIndexOf("\\") + 1);

    }
    
    //Delete folder of given path
    function DeleteFolder(PathName)
    {
        if(g_debugging)
            WScript.Echo("   + Deleting..." + PathName); 
        if(g_filesys.FolderExists(PathName))
        {
            try
            {
                DeleteSubFolder(PathName);
                g_filesys.DeleteFolder(PathName ,true);
                WScript.Echo("   - Folder Deleted : " + PathName); 
            }
            catch (ex)
            {
                g_success = false;
                g_failure.push(PathName);
                WScript.Echo("   - Deleting " +PathName + " Failed! - " + ex.message);
            }
        }
        else
        {
            if(g_debugging)
                WScript.Echo("   + Not Exist" + PathName); 
        }
    }

    //Delete sub folder with long pathname (longer than 256)
    function DeleteSubFolder(PathName)
    {
        var f = g_filesys.GetFolder(PathName); 
        var subfolders  = new Enumerator(f.SubFolders);
        for(;!subfolders.atEnd(); subfolders.moveNext())
        {
            var subf = g_filesys.GetFolder(subfolders.item());
            var name = subf.ShortPath;
            DeleteSubFolder(name);
            g_filesys.DeleteFolder(name,true);               
        }
    }

    //Delete folder of given path
    function DeleteFile(FileName)
    {
        if (g_filesys.FileExists(FileName))
        {
            if(g_debugging)
                WScript.Echo("   - Deleting..."); 
            try
            {
                g_filesys.DeleteFile(FileName,true);
                WScript.Echo("   - File Deleted : " + FileName); 
            }
            catch (ex)
            {
                g_success=false;
                g_failure.push(FileName);
                WScript.Echo("   - Deleting " +FileName + " Failed!" + ex.message);
            }
        }
        else
        {
            if(g_debugging)
                WScript.Echo("   + Not Exist" + FileName); 
        }
    }

    //List subfolder of given path
    function ListSubFolder(PathName)
    {
        if(fso.FolderExists(PathName))
        {
            var f = g_filesys.GetFolder(PathName);
            var subfolders  = new Enumerator(f.SubFolders);
            //log.writeline("Listing Subfolder of "+PathName)
            for(;!subfolders.atEnd(); subfolders.moveNext())
            {
                var subf = g_filesys.GetFolder(subfolders.item());
                log.writeline("SubFolder " + subf.Name);
            }
        }
    }

    //Delete All Data
    function RemoveAllData(OSVersion)
    {
        WScript.Echo("");
        WScript.Echo("Removing remaining Messenger folders and files...");
        //Sleep for 1 second
        WScript.Sleep(1000);
        //**Removing remaining program files
        WScript.Echo("  Removing Remaining Messenger Program Files... ");
        DeleteFolder(g_ProgramFilesPath+"\\Windows Live\\Messenger");
        DeleteFolder(g_ProgramFilesPath+"\\Windows Live\\Device Manager");
        DeleteFolder(g_ProgramFilesPath+"\\Windows Live\\Contacts");
        DeleteFolder(g_ProgramFilesPath+"\\Windows Live Contacts");
        //old files
        DeleteFolder(g_ProgramFilesPath+"\\MSN Messenger");
        
        //**Removing local setting files **//
        WScript.Echo("  Removing Messenger Local Setting Files... ");
        //Messenger local data. This includes Contacts member cache (block list, etc.)
        //   ALL Sharing Folders and Sharing Metadata
        DeleteFolder(g_LocalApplicationDataPath + "\\Microsoft\\Messenger");
        DeleteFolder(g_LocalApplicationDataPath + "\\Microsoft\\Phone for Windows Live Messenger");
        DeleteFolder(g_LocalApplicationDataPath + "\\Microsoft\\Windows Live Phone");
        DeleteFolder(g_LocalApplicationDataPath + "\\Microsoft\\Windows Live Device Manager");
        DeleteFolder(g_LocalApplicationDataPath + "\\Microsoft\\Windows Live Contacts");
        
        //removing messenger virtual store on vista machine
        if(OSVersion.startsWith("6.0"))
            if(g_machine == "32bit" )
            {
                DeleteFolder(g_LocalApplicationDataPath + "\\VirtualStore\\Program Files\\Windows Live\\Messenger");
                DeleteFolder(g_LocalApplicationDataPath + "\\VirtualStore\\Program Files\\MSN Messenger");
            }
            else
            {
                DeleteFolder(g_LocalApplicationDataPath + "\\VirtualStore\\Program Files (x86)\\Windows Live\\Messenger");
                DeleteFolder(g_LocalApplicationDataPath + "\\VirtualStore\\Program Files (x86)\\MSN Messenger");
            }
            
        //**Removing application data setting files **//
        //%USERPROFILE%\AppData\Roaming\Microsoft\Messenger
        WScript.Echo("  Removing Messenger App Data Files... ");
        DeleteFolder(g_ApplicationDataPath + "\\Microsoft\\MSN Messenger");
        DeleteFolder(g_ApplicationDataPath + "\\Microsoft\\Windows Live Call");
        
        //**Removing Contacts Cache Files **//
        WScript.Echo("  Removing Local Contatcts Cache... ");
        DeleteFolder(g_UserProfile +"\\Contacts");
        
        //**Removing Old Messenger Files **//
        WScript.Echo("  Removing Old Version Files... ");
        //Removing Old MCCDB
        DeleteFolder(g_LocalApplicationDataPath +"\\Microsoft\\MSN\\MCCDB");
        //Removing Old Application Data
        DeleteFolder(g_ApplicationDataPath + "\\Microsoft\\MSN Messenger");
        //Removing Old Local Application Data
        DeleteFolder(g_LocalApplicationDataPath + "\\Microsoft\\MSN Messenger");
        //Removing select Messenger XML config files from c:
        DeleteFile("c:\config.dbg.xml");
        DeleteFile("c:\dbg.config.xml");
        DeleteFile("c:\alerts.xml");
        
        //**Delete Identity CRL (Integrated Passport sign-in) **//
        WScript.Echo("  Removing Identity CRL... ");
        DeleteFolder(g_ApplicationDataPath + "\\Microsoft\\IdentityCRL");
        
        //**Removing logs under My Received Files **//
        var MyRecivedFiles = g_MyDoucmentPath+"\\My Received Files";
        WScript.Echo("  Removing logs from "+MyRecivedFiles);
        DeleteFile(g_MyDoucmentPath + "\\MsnMsgr.txt");
        DeleteFile(g_MyDoucmentPath + "\\LCAPI0.log");
        DeleteFile(g_MyDoucmentPath + "\\Transport0.log");
        
        //**Removing Temp Cached Files **//
        //ASSERT: Delete Temp Files not needed after Messenger Nov05 builds moved local store to MSGRFILES folder.
        //Only user@domain.com addresses and MsnMsgr_ObjectStoreCache folders need deleting
        //NewNuke only removes MessengerCache and MusicMix
        WScript.Echo("  Removing Temp Cache... ");
        DeleteFolder(g_TempPath+"\\MessengerCache");
        DeleteFolder(g_TempPath+"\\MusicMix");
        
        //**Removing debug files **//
        WScript.Echo("  Removing Debug Files... ");
        //Delete rogue dll installed by old Messenger Wave3 internal build (~5/9/2007)
        DeleteFile(g_windir+"\\debugsvc.dll");
        
        //things not be cleaned
        /*
         *P4 application in C:\WINDOWS\Downloaded Program Files
         *My Received Files other than old logs.
         */
        
        if(g_success==false)
        {
            WScript.Echo("");
            WScript.Echo("Warning!!!");
            WScript.Echo(" The following files/folders couldn't be removed...");
            WScript.Echo(g_failure.join("\n"));
        }
    }
    
    //Get Local Time
    function GetTime()
    {
        var d, s = "";
        var c = ":";
        d = new Date();
        s += d.getHours() + c;
        s += d.getMinutes() + c;
        s += d.getSeconds();
        return(s);
    }
    
    //Get Local Time
    function GetDate()
    {
        var d, s = "";           //Declare variables.
        d = new Date();                  //Create Date object.
        s += d.getYear()+ "/";                 //Get year.
        s += (d.getMonth() + 1) + "/";         //Get month
        s += d.getDate();                      //Get day
        return(s);                             //Return date.
    }

    //log the results
    function LogResults()
    {
        try
        {
            
            var log= g_filesys.OpenTextFile(g_runningPath + "\\log.txt", 8, false);
            //return if the path is not avaliable
            if(log==null)
                return;
            if(g_success)
                log.writeline(GetDate() +" "+GetTime() +" User: " + g_UserDomain +"\\"+ g_UserName +", " + g_machine +" OS: "+g_OSName + ", ComputerName: "+g_ComputerName +" - Success!");
            else log.writeline(GetDate() +" "+GetTime() +" User: " + g_UserDomain +"\\"+ g_UserName +", " + g_machine +" OS: "+g_OSName + ", ComputerName: "+g_ComputerName +" - Failed!");
            log.writeline();
            log.Close();
        }
        catch(ex)
        {
WScript.Echo(g_runningPath + "\\log.txt" + "log failed");
        }
    }
    
    //Warning message
    function WarningMessage(filename, version)
    {
		WScript.Echo("******** ********* ********* ********* ********* ********* ********* *********" );
		WScript.Echo("**                  Messenger Deep Clean  ");
		WScript.Echo("**                 Version "+version);
		WScript.Echo("******** ********* ********* ********* ********* ********* ********* *********" );
		WScript.Echo("** "+ filename + " - cleans Messenger 8.0 and later version ONLY!!" );
		WScript.Echo("**");
		WScript.Echo("** WARNING: DATA LOSS CAUSED BY THIS SCRIPT!" );
		WScript.Echo("**     1. Uninstalls Messenger and Sign in assistant." );
		WScript.Echo("**     2. Messenger Data and Program folders (Sharing Folders, etc.)" );
		WScript.Echo("**     3. Object and Contact Store are deleted (All Winks, Dynamic content, etc.)" );
		WScript.Echo("**     4. Temp files of MessengerCache and MusicMix " );
		WScript.Echo("**     5. Regkeys related to Messenger ALL deleted (MSNMessenger, UCCP, etc." );
		WScript.Echo("** NOTE: Purge targets based observations. E-mail KenZhan with Feedback." );
		WScript.Echo("**       Details in readme.txt file." );
		WScript.Echo("******** ********* ********* ********* ********* ********* ********* *********" );
		WScript.Echo("" );		
		WScript.Echo("** Confirm before proceeding..." );
		WScript.Echo("**    WARNING: Goal is to clean as if Messenger was never installed." );
		WScript.Echo("**    ISSUE: This script might force silent close of Outlook or reboot on Vista." );
		WScript.Echo("" );
		WScript.Echo("** To terminate this warning use option -q or -Q for quiet uninstall." );
		WScript.Echo("" );	
		WScript.Echo("Press Enter to continue or Ctrl+C to cancel ..." );
	}

    