/**************************************************************
 * Removes All Windows Live Messenger Registry Entries
 *
 * History
 * 7/27/07 : rychen : Created
 * 7/31/07 : kenzhan : Add more partner registry keys need to be cleaned
 * 7/31/07 : kenzhan : Added \" to quote all rgStrRegs[iStrReg] in reg query and delete
 *
 **************************************************************/

var rgStrRegs=new Array("HKCU\\Software\\Microsoft\\MSNMessenger",
                        "HKCU\\AppEvents\\EventLabels\\MSNMSGR_Buzz",
                        "HKCU\\AppEvents\\EventLabels\\MSNMSGR_ContactOnline",
                        "HKCU\\AppEvents\\EventLabels\\MSNMSGR_NewAlert",
                        "HKCU\\AppEvents\\EventLabels\\MSNMSGR_NewMail",
                        "HKCU\\AppEvents\\EventLabels\\MSNMSGR_NewMessage",
                        "HKCU\\AppEvents\\EventLabels\\MSNMSGR_NewSMSMessage",
                        "HKCU\\AppEvents\\EventLabels\\MSNMSGR_PhoneRing",
                        "HKCU\\AppEvents\\EventLabels\\MSNMSGR_VoiceIMFinished",
                        "HKCU\\AppEvents\\Schemes\\Apps\\MSNMSGR",
                        "HKCU\\Software\\Microsoft\\IdentityCRL",
                        "HKCU\\Software\\Microsoft\\RTC\\{A5B45060-354F-4097-A928-5125436C46F1}",
                        "HKCU\\Software\\Microsoft\\SQMClient",
                        "HKCU\\Software\\Microsoft\\Windows Live\\Communications Clients",

                        //2007.05.04 Messenger 8.1 Windows Live Call has specific regkey per Windows Live bug387586 -zephans
                        "HKCU\\Software\\Microsoft\\PCS",
                        //2007.08.04 Wave 3 Messenger adopted UCCP platform
                        "HKCU\\Software\\Microsoft\\UCCPlatform\\WindowsLiveMessenger",
                        //partner registry need to be cleaned
                        "HKCU\\Software\\Microsoft\\Windows Live Call",
                        "HKCU\\Software\\Microsoft\\MSNDeviceManager",
                        "HKCU\\Software\\Microsoft\\Windows Live Contacts",

                        //HKLM
                        "HKLM\\Software\\Microsoft\\Windows Live Call",
                        "HKLM\\Software\\Microsoft\\MSNDeviceManager",
                        "HKLM\\Software\\Microsoft\\MSNMessenger",
                        "HKLM\\Software\\Microsoft\\RTC\\{A5B45060-354F-4097-A928-5125436C46F1}",
                        "HKLM\\Software\\Microsoft\\UCCPlatform\\WindowsLiveMessenger",
                        //2007.03.06 Messenger 8.5.1804.0301 and later use 'HKLM...Windows Live' instead of 'HKLM...MSNMessenger' -zephans
                        "HKLM\\Software\\Microsoft\\Windows Live\\Communications Clients",
                        "HKLM\\SYSTEM\\CurrentControlSet\\Services\\usnsvc"
                        );

function RemoveAllRegistry()
{
    WScript.Echo("Removing Registry...");
    var objShell=WScript.CreateObject("WScript.Shell");
    
    if (null == objShell)
    {
        WScript.Echo("Failed to create a Shell object.");
        return;
    }
    
    var fSuccess=true;
    
    for (var iStrReg in rgStrRegs)
    {
        if (objShell.Run("reg.exe QUERY \"" + rgStrRegs[iStrReg]+"\"", 0, true) != 0)
        {
            // If the registry key does not exist, print a message and move on to the next
            WScript.Echo("    \"" + rgStrRegs[iStrReg] + "\" does not exist or has already deleted");
        }
        else
        {
            if (objShell.Run("reg.exe DELETE \"" + rgStrRegs[iStrReg] + "\" /f", 0, true) != 0)
            {
                fSuccess=false;
                WScript.Echo("    Failed to delete registry \"" + rgStrRegs[iStrReg] + "\"");
            }
            else
            {
                WScript.Echo("    \"" + rgStrRegs[iStrReg] + "\" successfully deleted");
            } 
        }         
    }   
             
    if (fSuccess)
    { 
        WScript.Echo("All Messenger registry entries successfully removed.");
    }
    else
    {
        WScript.Echo("Some Messenger registry entries were not removed.");
    }
}